package	jp.co.sds_corp.util.msg.jms;

import javax.jms.Destination;

/**
* JMS-QUEUEの親クラス
*/
public class JmsQueuePackage extends AbstractJmsPackage
{ 
	/**
	*　送信リソースを生成します
	* @param	queue	送信者
	* @param	use		JNDIの使用有無
	*/
	public void createSender( String queue, boolean use ) throws Exception {
		if ( use ) {
			sendDest = (Destination )jndi.lookup( queue );
		} else {
			sendDest = sndSession.createQueue( queue );
		}
		sender = sndSession.createProducer( sendDest );
	}

	/**
	* 受信リソースを生成します
	* @param	queue	受信者
	* @param	cond	受信条件
	* @param	wait	(true:wait false: non wait)
	* @param	use		JNDIの使用有無
	*/
	public void createReceiver( String queue, String cond, boolean wait, boolean use )
		throws Exception
	{
		if ( use ) {
			recvDest = (Destination )jndi.lookup( queue );
		} else {
			recvDest = rcvSession.createQueue( queue );
		}
		if ( cond == null ) {
			receiver = rcvSession.createConsumer( recvDest );
		} else {
			receiver = rcvSession.createConsumer( recvDest, cond, false );
		}
		if ( !wait ) {
			receiver.setMessageListener( this );
		}
		this.wait = wait;
	}

}
