package	jp.co.sds_corp.util.msg.jms;

import javax.jms.Destination;

/**
* JMS 発行／購読型メッセージングサービス
*/
public class JmsTopicPackage extends AbstractJmsPackage
{
	/**
	* 送信リソースを生成します
	* @param	topic	送信者
	* @param	use		JNDIの使用有無
	*/
	public void createSender( String topic, boolean use ) throws Exception {
		if ( use ) {
			sendDest = (Destination )jndi.lookup( topic );
		} else {
			sendDest = sndSession.createTopic( topic );
		}
		sender = sndSession.createProducer( sendDest );
	}

	/**
	* 受信リソースを生成します
	* @param	topic	受信者
	* @param	cond	受信条件
	* @param	wait	(true : wait false: non wait)
	* @param	use		JNDIの使用有無
	*/
	public void createReceiver( String topic, String cond, boolean wait, boolean use )
		throws Exception
	{
		if ( use ) {
			recvDest = (Destination )jndi.lookup( topic );
		} else {
			recvDest = sndSession.createTopic( topic );
		}
		if ( cond == null ) {
			receiver = sndSession.createConsumer( recvDest );
		} else {
			receiver = sndSession.createConsumer( recvDest, cond, false );
		}
		if ( !wait ) {
			receiver.setMessageListener( this );
		}
		this.wait = wait;
	}

}
